#line 1 "D:/MicroC/Microwave_timer/MyProject.c"
#line 14 "D:/MicroC/Microwave_timer/MyProject.c"
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;



sbit Soft_I2C_Scl at RA6_bit;
sbit Soft_I2C_Sda at RA7_bit;
sbit Soft_I2C_Scl_Direction at TRISA6_bit;
sbit Soft_I2C_Sda_Direction at TRISA7_bit;


const char dot=':';
const sl='/';

char msg_setup[]="Set";
char msg_hour[]= "Hr:";
char msg_mins[]= "Mn:";
char msg_date[]= "Dt:";
char msg_mnt[]= "Mo:";
char msg_year[]= "Yr:";

unsigned char *hour, *mins, *secs, *date, *mth;

signed char SetHour, SetMins, SetDate, SetMnt, SetYear, out;

char ButtTimer;

signed char TimerMin, TimerSec;

char k;


const char msg[8][8] =
 {

 {31,31,24,24,24,24,24,0},
 {31,31,3,3,3,3,3,0},
 {3,3,3,3,3,31,31,0},
 {24,24,24,24,24,31,31,0},
 {31,31,3,3,3,31,31,0},
 {31,31,24,24,24,31,31,0},
 {31,31,0,0,0,0,0,0},
 {0,0,0,0,0,31,31,0},
 };



void CustomProg(char set) {
 char i,j;
 for (j=0; j<=7; j++) {
 Lcd_Cmd(64+(8*j));
 for (i=0; i<=7; i++) Lcd_Chr_CP(msg[j][i]);
 }
}


void Read_DS1307(char *hour, char *mins, char *secs, char *date, char *mth){
 char sec_t = 0;
 char mn_t = 0;
 char hr_t = 0;
 char day_t = 0;
 char mth_t = 0;
 Soft_I2C_Start();
 Soft_I2C_Write(0xD0);
 Soft_I2C_Write(0x00);
 Soft_I2C_Start();
 Soft_I2C_Write(0xD1);
 sec_t = Soft_I2C_Read(1);
 mn_t = Soft_I2C_Read(1);
 hr_t = Soft_I2C_Read(1);
 Soft_I2C_Read(1);
 day_t = Soft_I2C_Read(1);
 mth_t = Soft_I2C_Read(1);
 Soft_I2C_Read(0);
 Soft_I2C_Stop();
 *secs = Bcd2Dec(sec_t & 0x7F);
 *mins = Bcd2Dec(mn_t & 0x7F);
 *hour = Bcd2Dec(hr_t & 0x3F);
 *date = Bcd2Dec(day_t & 0x3F);
 *mth = Bcd2Dec(mth_t & 0x1F);
}


void Write_DS1307(char hour, char mins, char secs, char date, char mth, char year){
 char dwcnt = 1;
 Soft_I2C_Start();
 Soft_I2C_Write(0xD0);
 Soft_I2C_Write(0x00);
 Soft_I2C_Write(Dec2Bcd(secs & 0x7F));
 Soft_I2C_Write(Dec2Bcd(mins & 0x7F));
 Soft_I2C_Write(Dec2Bcd(hour & 0x3F));
 Soft_I2C_Write(Dec2Bcd(dwcnt));
 Soft_I2C_Write(Dec2Bcd(date & 0x3F));
 Soft_I2C_Write(Dec2Bcd(mth & 0x1F));
 Soft_I2C_Write(Dec2Bcd(year));
 Soft_I2C_Write(0x10);
 Soft_I2C_Stop();
}


void WriteByte(char row, char col, char number){
 char *bytetext = "00";
 bytetext[0] = (number/10)%10 + 48;
 bytetext[1] = number%10 + 48;
 Lcd_Out(row, col, bytetext);
}


void WriteBig(char row, char col, char number){
 char ob[8];
 char dig1, dig2;
 dig1 = (number/10)%10;
 dig2 = number%10;
 switch(dig1){
 case 0: {ob[0]=0; ob[1]=1; ob[4]=3; ob[5]=2;} break;
 case 1: {ob[0]=1; ob[1]=' '; ob[4]=2; ob[5]=7;} break;
 case 2: {ob[0]=6; ob[1]=4; ob[4]=5; ob[5]=7;} break;
 case 3: {ob[0]=6; ob[1]=4; ob[4]=7; ob[5]=2;} break;
 case 4: {ob[0]=3; ob[1]=2; ob[4]=' '; ob[5]=1;} break;
 case 5: {ob[0]=5; ob[1]=6; ob[4]=7; ob[5]=4;} break;
 case 6: {ob[0]=0; ob[1]=6; ob[4]=5; ob[5]=4;} break;
 case 7: {ob[0]=6; ob[1]=1; ob[4]=' '; ob[5]=1;} break;
 case 8: {ob[0]=5; ob[1]=4; ob[4]=3; ob[5]=2;} break;
 case 9: {ob[0]=5; ob[1]=4; ob[4]=7; ob[5]=2;} break;
 }
 switch(dig2){
 case 0: {ob[2]=0; ob[3]=1; ob[6]=3; ob[7]=2;} break;
 case 1: {ob[2]=1; ob[3]=' '; ob[6]=2; ob[7]=7;} break;
 case 2: {ob[2]=6; ob[3]=4; ob[6]=5; ob[7]=7;} break;
 case 3: {ob[2]=6; ob[3]=4; ob[6]=7; ob[7]=2;} break;
 case 4: {ob[2]=3; ob[3]=2; ob[6]=' '; ob[7]=1;} break;
 case 5: {ob[2]=5; ob[3]=6; ob[6]=7; ob[7]=4;} break;
 case 6: {ob[2]=0; ob[3]=6; ob[6]=5; ob[7]=4;} break;
 case 7: {ob[2]=6; ob[3]=1; ob[6]=' '; ob[7]=1;} break;
 case 8: {ob[2]=5; ob[3]=4; ob[6]=3; ob[7]=2;} break;
 case 9: {ob[2]=5; ob[3]=4; ob[6]=7; ob[7]=2;} break;
 }
 Lcd_Chr(row,col,ob[0]);
 Lcd_Chr(row,col+1,ob[1]);
 Lcd_Chr(row+1,col,ob[4]);
 Lcd_Chr(row+1,col+1,ob[5]);

 Lcd_Chr(row,col+2,ob[2]);
 Lcd_Chr(row,col+3,ob[3]);
 Lcd_Chr(row+1,col+2,ob[6]);
 Lcd_Chr(row+1,col+3,ob[7]);
}


void adjust(char min, char max){
 do{
 if ( PORTA.F2  == 1) out++;
 if (out>max) out=min;
 if ( PORTA.F3  == 1) out--;
 if (out<min) out=max;
 WriteByte(2,8,out);
 delay_ms(500);
 }
 while( PORTA.F4  == 0);
}


void setuptime(){
 char txt[3];
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,msg_setup);
 while ( PORTA.F5  == 1){};

 Lcd_Out(2,2,msg_hour);
 out=Hour;
 adjust(0,23);
 SetHour=out;
 delay_ms(10);
 while ( PORTA.F4  == 1){};

 Lcd_Out(2,2,msg_mins);
 out=Mins;
 adjust(0,59);
 SetMins=out;
 delay_ms(10);
 while ( PORTA.F4  == 1){};

 Lcd_Out(2,2,msg_date);
 out=Date;
 adjust(1,31);
 SetDate=out;
 delay_ms(10);
 while ( PORTA.F4  == 1){};

 Lcd_Out(2,2,msg_mnt);
 out=mth;
 adjust(1,12);
 SetMnt=out;
 delay_ms(10);
 while ( PORTA.F4  == 1){};

 Lcd_Out(2,2,msg_year);
 out=13;
 adjust(1,99);
 SetYear=out;

 Write_DS1307(SetHour,SetMins,0,SetDate,SetMnt,SetYear);
 Lcd_Cmd(_LCD_CLEAR);
}


void Run(){
 char k, newsec;
 char oldsec=99;
  PORTA.F0 =1;
 delay_ms(1000);
  PORTA.F1 =1;
 while ((TimerSec>0)||(TimerMin>0))
 {
 Read_DS1307(&hour, &mins, &secs, &date, &mth);
 newsec = secs;
 if (oldsec != newsec)
 {
 TimerSec--;
 if (TimerSec<0) {TimerSec=59; TimerMin--;}
 oldsec=newsec;
 }
 WriteBig(1,2,TimerMin);
 WriteBig(1,7,TimerSec);
 if (( PORTB.F0  == 0)||( PORTA.F5 )) break;
 }
  PORTA.F1 =0;
 if (( PORTB.F0 )&&( PORTA.F5  == 0))
 {
 for(k=0;k<3;k++)
 {
  PORTB.F1 =1;
 delay_ms(500);
  PORTB.F1 =0;
 delay_ms(500);
 }
 }
  PORTA.F0 =0;
}


void TimerSet(){
 bit OldUp, OldDn;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Chr(1,6,0x5F);
 TimerMin=0;
 TimerSec=0;
 do {
 if ( PORTA.F2 ==0) OldUp=0;
 if (( PORTA.F2 ==1)&&(OldUp==0))
 {
 TimerSec+=30;
 if (TimerSec>30) {TimerSec=0; TimerMin++;}
 OldUp=1;
 delay_ms(10);
 }
 if ( PORTA.F3 ==0) OldDn=0;
 if (( PORTA.F3 ==1)&&(OldDn==0))
 {
 TimerSec-=30;
 if (TimerSec<0) {TimerSec=30; TimerMin--;}
 if (TimerMin<0) TimerMin=0;
 OldDn=1;
 delay_ms(10);
 }
 WriteBig(1,2,TimerMin);
 WriteBig(1,7,TimerSec);
 if (( PORTA.F4 ==1)&&((TimerSec>0)||(TimerMin>0))) Run();
 } while (( PORTA.F5  == 0)&&( PORTB.F0 ));

 Lcd_Cmd(_LCD_CLEAR);
}


void main() {
 INTCON=0;
 CMCON=7;
 TRISA=0b11111100;
 TRISB=0b11111101;
  PORTB.F1 =0;
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 CustomProg(0);
 Butttimer=0;
 while(1)
 {
 Read_DS1307(&hour, &mins, &secs, &date, &mth);
 WriteByte(1,1,hour);
 Lcd_Chr(1,3,dot);
 WriteByte(1,4,mins);
 Lcd_Chr(1,6,dot);
 WriteByte(1,7,secs);
 WriteByte(2,1,date);
 Lcd_Chr(2,3,sl);
 WriteByte(2,4,mth);

 if ( PORTA.F5  == 0) ButtTimer = 0; else Butttimer++;
 if (ButtTimer == 0x7F) SetupTime();
 if ((( PORTA.F2  == 1)||( PORTA.F3  == 1))&&( PORTB.F0 )) TimerSet();
 }
 }
